#include <windows.h>
#include "3d.h"

LPCSTR szWindowClass = "SAMPLE_CLASS";
LPCSTR szWindowTitle = "3DeXg";

LRESULT CALLBACK WndProc(HWND hWnd, UINT message,
                         WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT ps;
    HDC hdc;
    RECT clearrect;
    static camera_t camera;
    static HPEN redpen,greenpen,bluepen,oldpen;
    char info[1025];

    switch (message) {
		case WM_CREATE:
			SetTimer(hWnd,0,20,NULL);
			camera.x=0;
			camera.y=0;
			camera.z=0;
			/*camera.cx=-3.14/180*20;
			camera.cy=-3.14/180*20;*/
			camera.cx=0;
			camera.cy=0;
			camera.cz=0;
			/*camera.cx=-0.5410;
			camera.cy=-0.5759;
			camera.cz=0.2792;*/
			camera.genkai=320;
			camera.genkaiangle=dec2rad(50);
			camera.centerx=320;
			camera.centery=240;
			clearrect.top=0;
			clearrect.left=0;
			clearrect.right=640;
			clearrect.bottom=480;
			redpen=CreatePen(PS_SOLID,1,RGB(255,0,0));
			greenpen=CreatePen(PS_SOLID,1,RGB(0,255,0));
			bluepen=CreatePen(PS_SOLID,1,RGB(0,0,255));
			break;
	    case WM_COMMAND:
    	    switch (LOWORD(wParam)) {
        		default:
            		return DefWindowProc(hWnd, message, wParam, lParam);
			}
        	break;
	    case WM_PAINT:
    	    hdc = BeginPaint(hWnd, &ps);
    	    FillRect(hdc,&clearrect,GetStockObject(WHITE_BRUSH));
    	    
    	    SetBkMode(hdc,TRANSPARENT);
    	    wsprintf(info,"W(%d,%d,%d)",(int)camera.x,(int)camera.y,(int)camera.z);
    	    TextOut(hdc,0,0,info,lstrlen(info));
    	    wsprintf(info,"x]*10000F%d",(int)(camera.cx*10000));
    	    TextOut(hdc,0,20,info,lstrlen(info));
    	    wsprintf(info,"y]*10000F%d",(int)(camera.cy*10000));
    	    TextOut(hdc,0,40,info,lstrlen(info));
    	    wsprintf(info,"z]*10000F%d",(int)(camera.cz*10000));
    	    TextOut(hdc,0,60,info,lstrlen(info));
    	    
    	    MoveToEx(hdc,315,235,NULL);
    	    LineTo(hdc,325,245);
    	    MoveToEx(hdc,315,245,NULL);
    	    LineTo(hdc,325,235);
    	    
    	    draw3dline(hdc,0,0,0,100,0,0,&camera);
    	    draw3dline(hdc,0,0,0,0,100,0,&camera);
    	    draw3dline(hdc,0,0,0,0,0,100,&camera);
    	    draw3dtext(hdc,100,0,0,"x",&camera);
    	    draw3dtext(hdc,0,100,0,"y",&camera);
    	    draw3dtext(hdc,0,0,100,"z",&camera);
    	    
    	    oldpen=SelectObject(hdc,redpen);
    	    draw3dline(hdc,0,0,200,0,0,300,&camera);
    	    draw3dline(hdc,0,0,300,100,0,300,&camera);
    	    draw3dline(hdc,100,0,300,100,0,200,&camera);
    	    draw3dline(hdc,100,0,200,0,0,200,&camera);
    	    
    	    SelectObject(hdc,greenpen);
    	    draw3dline(hdc,0,0,200,0,100,200,&camera);
    	    draw3dline(hdc,0,0,300,0,100,300,&camera);
    	    draw3dline(hdc,100,0,300,100,100,300,&camera);
    	    draw3dline(hdc,100,0,200,100,100,200,&camera);
    	    
    	    SelectObject(hdc,bluepen);
    	    draw3dline(hdc,0,100,200,0,100,300,&camera);
    	    draw3dline(hdc,0,100,300,100,100,300,&camera);
    	    draw3dline(hdc,100,100,300,100,100,200,&camera);
    	    draw3dline(hdc,100,100,200,0,100,200,&camera);
    	    
    	    /*y߂*/
    	    SelectObject(hdc,oldpen);
    	    
        	EndPaint(hWnd, &ps);
        	break;
        case WM_TIMER:
			/*ړ*/
			if(GetAsyncKeyState(VK_SHIFT) & 0x8000) {
				if(GetAsyncKeyState(VK_CONTROL) & 0x8000) {
					if(GetAsyncKeyState(VK_UP) & 0x8000)
						camera.cz-=dec2rad(1);
					if(GetAsyncKeyState(VK_DOWN) & 0x8000)
						camera.cz+=dec2rad(1);
				} else {
					if(GetAsyncKeyState(VK_UP) & 0x8000)
						camera.cx+=dec2rad(1);
					if(GetAsyncKeyState(VK_DOWN) & 0x8000)
						camera.cx-=dec2rad(1);
				}
				if(GetAsyncKeyState(VK_LEFT) & 0x8000)
					camera.cy-=dec2rad(1);
				if(GetAsyncKeyState(VK_RIGHT) & 0x8000)
					camera.cy+=dec2rad(1);
			} else {
				if(GetAsyncKeyState(VK_CONTROL) & 0x8000) {
					if(GetAsyncKeyState(VK_UP) & 0x8000)
						camera.z+=5;
					if(GetAsyncKeyState(VK_DOWN) & 0x8000)
						camera.z-=5;
				} else {
				if(GetAsyncKeyState(VK_UP) & 0x8000)
					camera.y+=5;
				if(GetAsyncKeyState(VK_DOWN) & 0x8000)
					camera.y-=5;
				}	
				if(GetAsyncKeyState(VK_LEFT) & 0x8000)
					camera.x-=5;
				if(GetAsyncKeyState(VK_RIGHT) & 0x8000)
					camera.x+=5;
			}
			/*W̃Zbg*/
			if(GetAsyncKeyState(VK_F1) & 0x8000) {
				camera.x=0;
				camera.y=0;
				camera.z=0;
				camera.cx=0;
				camera.cy=0;
				camera.cz=0;
				camera.centerx=320;
				camera.centery=240;
			}
			/*ĕ`*/
			InvalidateRect(hWnd,NULL,1);
			break;
    	case WM_DESTROY:
			KillTimer(hWnd,0);
			DeleteObject(redpen);
			DeleteObject(greenpen);
			DeleteObject(bluepen);
        	PostQuitMessage(0);
        	break;
    	default:
        	return DefWindowProc(hWnd, message, wParam, lParam);
   	}

    return 0;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
    MSG msg;
    WNDCLASSEX wcex;
    HWND hWnd;

    wcex.cbSize = sizeof(WNDCLASSEX);

    wcex.style          = CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc    = (WNDPROC)WndProc;
    wcex.cbClsExtra     = 0;
    wcex.cbWndExtra     = 0;
    wcex.hInstance      = hInstance;
    wcex.hIcon          = LoadIcon(NULL,IDI_APPLICATION);
    wcex.hCursor        = LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
    wcex.lpszMenuName   = NULL;
    wcex.lpszClassName  = szWindowClass;
    wcex.hIconSm        = NULL;

    RegisterClassEx(&wcex);

    hWnd = CreateWindow(szWindowClass,
        szWindowTitle, WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
        NULL, NULL, hInstance, NULL);

    if (!hWnd)
        return FALSE;

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

    while (GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return msg.wParam;
}
